HDU 2377 Bus Pass(最短路 SPFA)

版权声明:From: http://blog.csdn.net/tju_tahara https://blog.csdn.net/TJU_Tahara/article/details/52344793

Bus Pass

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 986    Accepted Submission(s): 409


Problem Description
You travel a lot by bus and the costs of all the seperate tickets are starting to add up. 

Therefore you want to see if it might be advantageous for you to buy a bus pass. 

The way the bus system works in your country (and also in the Netherlands) is as follows: 

when you buy a bus pass, you have to indicate a center zone and a star value. You are allowed to travel freely in any zone which has a distance to your center zone which is less than your star value. For example, if you have a star value of one, you can only travel in your center zone. If you have a star value of two, you can also travel in all adjacent zones, et cetera. 

You have a list of all bus trips you frequently make, and would like to determine the minimum star value you need to make all these trips using your buss pass. But this is not always an easy task. For example look at the following figure: 



Here you want to be able to travel from A to B and from B to D. The best center zone is 7400, for which you only need a star value of 4. Note that you do not even visit this zone on your trips! 
 

Input
On the first line an integert(1 <=t<= 100): the number of test cases. Then for each test case: 

One line with two integersnz(2 <=nz<= 9 999) andnr(1 <=nr<= 10): the number of zones and the number of bus trips, respectively. 

nz lines starting with two integers id i (1 <= id i <= 9 999) and mz i (1 <= mz i <= 10), a number identifying the i-th zone and the number of zones adjacent to it, followed by mz i integers: the numbers of the adjacent zones. 

nr lines starting with one integer mr i (1 <= mr i <= 20), indicating the number of zones the ith bus trip visits, followed by mr i integers: the numbers of the zones through which the bus passes in the order in which they are visited. 

All zones are connected, either directly or via other zones. 

 

Output
For each test case: 

One line with two integers, the minimum star value and the id of a center zone which achieves this minimum star value. If there are multiple possibilities, choose the zone with the lowest number. 

 

Sample Input
 
  
1 17 2 7400 6 7401 7402 7403 7404 7405 7406 7401 6 7412 7402 7400 7406 7410 7411 7402 5 7412 7403 7400 7401 7411 7403 6 7413 7414 7404 7400 7402 7412 7404 5 7403 7414 7415 7405 7400 7405 6 7404 7415 7407 7408 7406 7400 7406 7 7400 7405 7407 7408 7409 7410 7401 7407 4 7408 7406 7405 7415 7408 4 7409 7406 7405 7407 7409 3 7410 7406 7408 7410 4 7411 7401 7406 7409 7411 5 7416 7412 7402 7401 7410 7412 6 7416 7411 7401 7402 7403 7413 7413 3 7412 7403 7414 7414 3 7413 7403 7404 7415 3 7404 7405 7407 7416 2 7411 7412 5 7409 7408 7407 7405 7415 6 7415 7404 7414 7413 7412 7416
 

Sample Output
 
  
4 7400
 

Source
 
题意:
找一个点,使它到所有途径点的的最短路的最大值最小。(语文不好别介意)
思路:
把所有途径的点作为初始点进行SPFA。保留下多次最短路的最大值,再在这些最大值中取最小值即可。

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <map>
#include <queue>
#include <cmath>
#define MAXE 1001000
#define MAXV 101000
#define INF 0X3f3f3f3f
using namespace std;

struct node{
    int t, next, w;
}edge[MAXV];

int dist[MAXV], head[MAXV], tdist[MAXV], inde;
bool oc[MAXV];

void fresh(){
    memset(oc, 0, sizeof(oc));
    inde = 0;
    memset(head, -1, sizeof(head));
    for(int i = 0; i < MAXV; i++)
        dist[i] = -INF;
}

void addedge(int s, int t){
    edge[inde].t = t;
    edge[inde].w = 1;
    edge[inde].next = head[s];
    head[s] = inde++;
}

void spfa(int s, int l, int h){
    queue<int> que;
    que.push(s);
    int now, i;
    for(i = l; i <= h; i++) tdist[i] = INF;
    tdist[s] = 1;
    while(!que.empty()){
        now = que.front();
        que.pop();
        oc[now] = 0;
        i = head[now];
        while(i > 0){
            if(tdist[edge[i].t] > tdist[now] + edge[i].w){
                tdist[edge[i].t] = tdist[now] + edge[i].w;
                if(!oc[edge[i].t]){
                    oc[edge[i].t] = 1;
                    que.push(edge[i].t);
                }
            }
            i = edge[i].next;
        }
    }
    for(i = l; i <= h; i++){
        dist[i] = max(dist[i], tdist[i]);
    }
}

int main()
{
    int casen, num, qst, s, t, l, h, flag, i, j, res, pnt;
    scanf("%d", &casen);
    while(casen--){
        fresh();
        res = l = INF; h = -INF;
        scanf("%d%d", &num, &qst);
        for(i = 0; i < num; i++){
            scanf("%d%d", &s, &flag);
            l = min(l, s);
            h = max(h, s);
            for(j = 0; j < flag; j++){
                scanf("%d", &t);
                addedge(s,t);
                l = min(l, s);
                h = max(h ,s);
            }
        }
        for(i = 0; i < qst; i++){
            scanf("%d", &flag);
            for(j = 0; j < flag; j++){
                scanf("%d", &t);
                spfa(t, l, h);
            }
        }
        for(i = h; i >= l; i--){
            if(res >= dist[i]){
                res = dist[i];
                pnt = i;;
            }
        }
        printf("%d %d\n",res, pnt);
    }
    return 0;
}


猜你喜欢

转载自blog.csdn.net/TJU_Tahara/article/details/52344793